image: docker

stages:
  - build
  - test
  - push

variables:
  DOCKER_HOST: tcp://docker:2375/
  DOCKER_DRIVER: overlay2
  DOCKER_TLS_CERTDIR: ""

services:
  - docker:dind

before_script:
  - echo -n $CI_JOB_TOKEN | docker login -u gitlab-ci-token --password-stdin $CI_REGISTRY

'Build container for test':
  stage: build
  script:
    - docker build --pull --no-cache --tag ${CI_REGISTRY_IMAGE}:staging .
    # push
    - docker push ${CI_REGISTRY_IMAGE}:staging

'Test application':
  stage: test
  script:
    # test
    - docker run -i ${CI_REGISTRY_IMAGE}:staging python -m unittest
    # lint
    - docker run -i ${CI_REGISTRY_IMAGE}:staging flake8

'Push a new latest container to registry':
  stage: push
  variables:
    GIT_STRATEGY: none
  script:
    # pull test
    - docker pull ${CI_REGISTRY_IMAGE}:staging
    # tag latest
    - docker tag ${CI_REGISTRY_IMAGE}:staging ${CI_REGISTRY_IMAGE}:latest
    # push
    - docker push ${CI_REGISTRY_IMAGE}:latest
  only:
    refs:
      - master
      - schedules
